
#ifndef _SYSTEM_H
#define _SYSTEM_H

#define NULL ((void *)0)

/*
 * irq, fiq모두를 enable 혹은 disable 한다.
 */
#define ENTER_CRITICAL()	\
({				\
unsigned long temp;		\
__asm__ __volatile__(		\
	"mrs	%0, cpsr\n"	\
	"orr	%0, %0, #0xc0\n"\
	"msr	cpsr, %0\n"	\
	:"=r"(temp)		\
	:			\
	:"memory", "cc");	\
})
 

#define EXIT_CRITICAL()		\
({				\
unsigned long temp;		\
__asm__ __volatile__(		\
	"mrs	%0, cpsr\n"	\
	"bic	%0, %0, #0xc0\n"\
	"msr	cpsr, %0\n"	\
	:"=r"(temp)		\
	:			\
	:"memory", "cc");	\
})

void load_task(unsigned int task_number);

#endif
