
#include "shell.h"

struct list_command list_cmd[MAX_CMD];
unsigned int built_in_cmd_count;

/*
 * 실행가능한 명령어들을 초기화한다.
 */
void init_command()
{
    unsigned int i;

    for (i=0; i<MAX_CMD; i++) {
	list_cmd[i].command[0] = '\0';
	list_cmd[i].cmd_function = NULL;
    }
    
    built_in_cmd_count = 0;

    strcpy(list_cmd[built_in_cmd_count].command, "help");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_help;
    
    strcpy(list_cmd[built_in_cmd_count].command,"version");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_version;
    
    strcpy(list_cmd[built_in_cmd_count].command, "getdate");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_getdate;
    
    strcpy(list_cmd[built_in_cmd_count].command, "setdate");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_setdate;

    strcpy(list_cmd[built_in_cmd_count].command, "ps");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_ps;

    strcpy(list_cmd[built_in_cmd_count].command, "clear");
    list_cmd[built_in_cmd_count++].cmd_function = cmd_clear;
}

/*
 * 현재 사용가능한 명령어 리스트를 보여준다.
 * 정의되지 않은 명령어를 실행하였을 경우에도
 * 실행된다
 */
void cmd_help()
{
    unsigned int i;

    printf("use able command list\n");

    for (i=0; i<built_in_cmd_count; i++) {
	printf(" - %s\n", list_cmd[i].command);
    }

    printf("\n");
}

void cmd_version()
{
    printf("\n");

    version();

    printf("\n");    
}

void cmd_getdate()
{
    printf("\n");
    
    rtc_get_date();

    printf("\n");    
}

void cmd_setdate()
{
    printf("\n");
    
    rtc_set_date();

    printf("\n");    
}

void cmd_ps()
{
    printf("\n");


    
    printf("\n");
}

void cmd_clear()
{
    unsigned int i;
    
    for (i=0; i<40; i++)
	printf("\n");
}
