
#include "string.h"

#define isdigit(a)	((a) >= '0' && (a) <= '9')

int strlen(const char s[])
{
    int i;

    i = 0;
    while (s[i] != '\0')
	++i;

    return i;
}

void strcat(char s[], const char t[])
{
    int i, j;

    i = j = 0;
    while (s[i] != '\0')
	++i;
    
    while ((s[i] = t[j]) != '\0') {
	++i;
	++j;
    }
}

int strcpy(char s[], const char t[])
{
    int i;

    i = 0;
    while ((s[i] = t[i]) != '\0')
	++i;

    return i;
}

int strcmp(char *s1, char *s2)
{
    for ( ; *s1 == *s2; s1++, s2++) {
	if (*s1 == '\0' && *s2 == '\0')
	    return 0;
	else if (*s1 == '\0' || *s2 == '\0')
	    return *s1 - *s2;
    }

    return *s1 - *s2;
}

/*
 * ascii to integer 함수이다
 *
 * 리턴값이 -1이면 문자열에 숫자가 아닌 데이터가 있기 때문이다
 */
int atoi(const char *nptr)
{
    int temp, i, minus;
    unsigned char c;

    i = 0;
    temp = 0;
    minus = 1;

    if (nptr[0] == '-') {
	minus = -1;
	i = 1;
    }

    while ((c = nptr[i++]) != '\0') {
	if (!isdigit(c))
	    return -1;
	
	temp += (temp * 10) + c - '0';
    }
    temp = temp * minus;

    return temp;
}
